function [phi,TrackRes,p]=seg_JRACS(RGB,I,phi,noFrame,epislon_seg,fore_hist,back_hist,max_iter_num,nBin,lamda_segment,...
    saveTrackBmp,backgroundRatio,backgroundCurve)
%*************************************************************************
% Functiontracking result in the segmentation step
% Parameters:
%   RGBtracked frame;
%   I
%   noFrame:frame number
%   epislon_seg
%   fore_hist
%   back_hist
%   philevel set
%   max_iter_num: max iteration number
%   nBin
%   lamda_segmentweights to adjust foreground and background information
%   saveTrackBmpsaving tracking result 1:yes 0:no
%   videoFileNameis used to save tracking result
%   curModemode to call get_wfbx_JRACS
%   backgroundRatio: 0-1: the size of background size 
%   thresh_delta_p: convergence threshold of registration step
%   backgroundCurve: 1: draw backgrounnd curve  0: not
% Return
%   philevel set of registration result
%   TrackRes: registration result
%   j: iteration number of registration segmentation
% -------------------------------------------
% *************************************************************************

flag=1;
for p=1:max_iter_num
    if flag==0
        break;
    end
    [fore_hist_n back_hist_n,WF,WB,not1,not2,not3,border]=get_fore_back_hist_JRACS(I,phi,nBin,epislon_seg,backgroundRatio);
    % get the coordination of narrow band
    [band_x,band_y]=find(phi<=5 & phi>=-5);
    [Delta_h delta_s] = Delta2(phi,epislon_seg,band_x,band_y);

    H = Heaviside(phi,epislon_seg,band_x,band_y);
    
    % calculate wfi and wbi valude of narrow band 
    [Wfx,Wbx]=get_wfbx_JRACS(I,phi,band_x,band_y,WF,WB,fore_hist,fore_hist_n,back_hist,back_hist_n,H,nBin,lamda_segment);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    diff=Delta_h(:).*(Wfx(:)-Wbx(:));
    
    t=1/max(abs(diff));
    if mod(p,5)==1
        oldphi=phi>=0;
    end
    for p_n=1:size(Delta_h,1)
        phi(band_x(p_n),band_y(p_n))= phi(band_x(p_n),band_y(p_n))+t*diff(p_n);
    end
 
    for f=1:2
        phi=phi+0.24*4*del2(phi);
    end
    
    set(gcf,'DoubleBuffer','on');
    if (mod(p,5)==0)
        TrackRes=makeTrackingRes(RGB,phi,border,1);
        imshow(TrackRes);
        title(strcat(num2str(noFrame),' segment:',num2str(p),'/',num2str(max_iter_num)));
        drawnow
        
        % is it convergenced?
        newphi=(phi>=0)-oldphi;
        num=sum(abs(newphi(:)));          
        if (num<=5 || p==max_iter_num)       
            flag=0;
        end
    end    
end

Mask=zeros(size(phi));
Mask(phi>=0)=1;
phi = -mask2phi(Mask);
phi=reg_levelset(phi);

TrackRes=makeTrackingRes(RGB,phi,border,backgroundCurve);
tt1=getprefix(noFrame,10,100);
tt2=getprefix(p,0,100);
imwrite(TrackRes,['.\registration and segmentation\','_im',tt1,num2str(noFrame),'_seg_',tt2,num2str(p),'.jpg']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%